Subject: Re: linux-next: build failure after merge of the drm-misc tree

From: Thomas Zimmermann <[email-masked]>
Date: Wed, 23 Nov 2022 09:33:01 +0100

Hi

Am 23.11.22 um 06:35 schrieb David Airlie:
> On Wed, Nov 23, 2022 at 3:21 PM Stephen Rothwell <[email-masked]> wrote:
>>
>> Hi all,
>>
>> On Thu, 17 Nov 2022 18:32:14 +1100 Stephen Rothwell <[email-masked]> wrote:
>>>
>>> After merging the drm-misc tree, today's linux-next build (powerpc
>>> ppc44x_defconfig) failed like this:
>>>
>>> ld: drivers/video/fbdev/core/fbmon.o: in function `fb_modesetting_disabled':
>>> fbmon.c:(.text+0x1e4): multiple definition of `fb_modesetting_disabled'; drivers/video/fbdev/core/fbmem.o:fbmem.c:(.text+0x1bac): first defined here
>>> ld: drivers/video/fbdev/core/fbcmap.o: in function `fb_modesetting_disabled':
>>> fbcmap.c:(.text+0x478): multiple definition of `fb_modesetting_disabled'; drivers/video/fbdev/core/fbmem.o:fbmem.c:(.text+0x1bac): first defined here
>>> ld: drivers/video/fbdev/core/fbsysfs.o: in function `fb_modesetting_disabled':
>>> fbsysfs.c:(.text+0xb64): multiple definition of `fb_modesetting_disabled'; drivers/video/fbdev/core/fbmem.o:fbmem.c:(.text+0x1bac): first defined here
>>> ld: drivers/video/fbdev/core/modedb.o: in function `fb_modesetting_disabled':
>>> modedb.c:(.text+0x129c): multiple definition of `fb_modesetting_disabled'; drivers/video/fbdev/core/fbmem.o:fbmem.c:(.text+0x1bac): first defined here
>>> ld: drivers/video/fbdev/core/fbcvt.o: in function `fb_modesetting_disabled':
>>> fbcvt.c:(.text+0x0): multiple definition of `fb_modesetting_disabled'; drivers/video/fbdev/core/fbmem.o:fbmem.c:(.text+0x1bac): first defined here
>>>
>>> Caused by commit
>>>
>>>    0ba2fa8cbd29 ("fbdev: Add support for the nomodeset kernel parameter")
>>>
>>> This build does not have CONFIG_VIDEO_NOMODESET set.
>>>
>>> I applied the following patch for today.
>>>
>>>  From 63f957a050c62478ed1348c5b204bc65c68df4d7 Mon Sep 17 00:00:00 2001
>>> From: Stephen Rothwell <[email-masked]>
>>> Date: Thu, 17 Nov 2022 18:19:22 +1100
>>> Subject: [PATCH] fix up for "fbdev: Add support for the nomodeset kernel parameter"
>>>
>>> Signed-off-by: Stephen Rothwell <[email-masked]>
>>> ---
>>>   include/linux/fb.h | 2 +-
>>>   1 file changed, 1 insertion(+), 1 deletion(-)
>>>
>>> diff --git a/include/linux/fb.h b/include/linux/fb.h
>>> index 3a822e4357b1..ea421724f733 100644
>>> --- a/include/linux/fb.h
>>> +++ b/include/linux/fb.h
>>> @@ -807,7 +807,7 @@ extern int fb_find_mode(struct fb_var_screeninfo *var,
>>>   #if defined(CONFIG_VIDEO_NOMODESET)
>>>   bool fb_modesetting_disabled(const char *drvname);
>>>   #else
>>> -bool fb_modesetting_disabled(const char *drvname)
>>> +static inline bool fb_modesetting_disabled(const char *drvname)
>>>   {
>>>        return false;
>>>   }
>>> --
>>> 2.35.1
>>
>> This commit went away for a couple of linux-next releases, but now has
>> reappeared in the drm tree :-(  What went wrong?
> 
> Nothing gone wrong as such, just the drm-misc-next pull request was
> sent on a regular weekly cadence, then I merged it a few days later.
> The fix for this is still in the drm-misc-next queue for the next PR
> which I will get this week.

The next PR should be drm-misc-next-fixes. FYI I forwarded the tree and 
cherry-picked the patch from drm-misc-next.

Best regards
Thomas

> Dave.

-- 
Thomas Zimmermann
Graphics Driver Developer
SUSE Software Solutions Germany GmbH
Maxfeldstr. 5, 90409 Nürnberg, Germany
(HRB 36809, AG Nürnberg)
Geschäftsführer: Ivo Totev